#include "syscall.h"

DEFN_SYSCALL1(puts,  0, UCHAR*);
DEFN_SYSCALL0(test,  1)
DEFN_SYSCALL2(test1, 2, ULONG, ULONG)

ULONG num_syscalls  = 3;
static void* syscalls[3] =
{
    &puts,
    &test,
    &test1
};


void syscall_handler(struct regs* regs);

//void syscalls_install(){ register_interrupt_handler( 127, &syscall_handler ); } //TODO

void syscall_handler(struct regs* regs)
{
    // Firstly, check if the requested syscall number is valid. The syscall number is found in EAX.

    if (regs->eax >= num_syscalls)
        return;

    // Get the required syscall location.
    void *location = syscalls[regs->eax];

    // We don't know how many parameters the function wants, so we just
    // push them all onto the stack in the correct order. The function will
    // use all the parameters it wants, and we can pop them all back off afterwards.
    int ret;
    asm volatile (" \
      push %1; \
      push %2; \
      push %3; \
      push %4; \
      push %5; \
      call *%6; \
      pop %%ebx; \
      pop %%ebx; \
      pop %%ebx; \
      pop %%ebx; \
      pop %%ebx; \
    " : "=a" (ret) : "r" (regs->edi), "r" (regs->esi), "r" (regs->edx), "r" (regs->ecx), "r" (regs->ebx), "r" (location));
    regs->eax = ret;
}

